<?php
//Crypto :D

//My own modification of ARC4
class ARCbwall
{
	protected $state;
	protected $i = 0;
	protected $j = 0;
	protected $k = 0;
	
	//Swaps i, j, k
	function Swap()
	{
		$temp = $this->state[$this->i];
		$this->state[$this->i] = $this->state[$this->j];
		$this->state[$this->j] = $this->state[$this->k];
		$this->state[$this->k] = $temp;
	}
	
	function Init($data)
	{
		$this->state = array();
		for($this->i = 0; $this->i < 256; $this->i++)
		{
			$this->state[$this->i] = $this->i;
		}
		$this->j = 0;
		$this->k = 0;
		for($this->i = 0; $this->i < 256; $this->i++)
		{
			$this->j = ($this->j + $this->state[$this->i] + ord($data[$this->i % strlen($data)])) % 256;
			$this->k = pow($this->k + $this->j, 2) % 256;
			$this->Swap();
		}
		$this->i = 0;
		$this->j = 0;
		$this->k = 0;
	}
	
	function GetByte()
	{
		$this->i = ($this->i + 1) % 256;
		$this->j = ($this->j + $this->state[$this->i]) % 256;
		$this->k = pow($this->k + $this->j, 2) % 256;
		$this->Swap();
		return $this->state[($this->i + $this->j + $this->k) % 256];
	}
	
	public function Crypt($data)
	{
		$ret = "";
		for($x = 0; $x < strlen($data); $x++)
		{
			$ret .= chr(ord($data[$x]) ^ $this->GetByte());
		}
		return $ret;
	}
	
	public function __construct($key)
	{
		$this->Init($key);
	}
}
?>
