<?php
/*
Plugin Name: WordPress Attack Scanner(free)
Plugin URI:  http://www.attack-scanner.com/
Description: Checks for various for admins to review on the Dashboard "Attack Scanner" tab.
Author: <a href="https://www.twitter.com/xxdigipxx/" target="_blank">@xxDigiPxx</a>
Version: 0.1.9.beta
Author URI: http://www.attack-scanner.com/
License: GNU Lesser General Public License

Copyright: 2012 by bwall & DigiP

"Don't try to do two things at once and expect to do justice to both"

*/

//error_reporting(E_ALL); 
// <-- This can actually cause problems, with other plugins!! 
// Use when debugging ONLY - If the other plugins actually throw errors, they will show on the whole site, making it seem like OUR plug-in is the problem!!

//error_reporting(0);

/*
 * Start Update Code
 */
 
$api_url = 'http://www.attack-scanner.com/attack-scanner/';
$plugin_slug = basename(dirname(__FILE__));

// Take over the update check
add_filter('pre_set_site_transient_update_plugins', 'check_for_plugin_update');

function check_for_plugin_update($checked_data) {
	global $api_url, $plugin_slug;

	if (empty($checked_data->checked))
		return $checked_data;

	$args = array(
		'slug' => $plugin_slug,
		'version' => $checked_data->checked[$plugin_slug .'/'. $plugin_slug .'.php'],
	);
	$request_string = array(
			'body' => array(
				'action' => 'basic_check', 
				'request' => serialize($args),
				'api-key' => md5(get_bloginfo('url'))
			),
			'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url')
		);

	// Start checking for an update
	$raw_response = wp_remote_post($api_url, $request_string);

	if (!is_wp_error($raw_response) && ($raw_response['response']['code'] == 200))
		$response = unserialize($raw_response['body']);

	if (is_object($response) && !empty($response)) // Feed the update data into WP updater
		$checked_data->response[$plugin_slug .'/'. $plugin_slug .'.php'] = $response;

	return $checked_data;
}


// Take over the Plugin info screen
add_filter('plugins_api', 'plugin_api_call', 10, 3);

	function plugin_api_call($def, $action, $args) {
		global $plugin_slug, $api_url;

		if ($args->slug != $plugin_slug)
			return false;

		// Get the current version
		$plugin_info = get_site_transient('update_plugins');
		$current_version = $plugin_info->checked[$plugin_slug .'/'. $plugin_slug .'.php'];
		$args->version = $current_version;

		$request_string = array(
				'body' => array(
					'action' => $action, 
					'request' => serialize($args),
					'api-key' => md5(get_bloginfo('url'))
				),
				'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo('url')
			);


			
		$request = wp_remote_post($api_url, $request_string);

		if (is_wp_error($request)) {
			$res = new WP_Error('plugins_api_failed', __('An Unexpected HTTP Error occurred during the API request.</p> <p><a href="?" onclick="document.location.reload(); return false;">Try again</a>'), $request->get_error_message());
		} else {
		
		
			// Backup Log Files before upgrading.
			if (!file_exists(dirname(__FILE__)."/../wp-attack-scanner-free-logs/")) {
				mkdir((dirname(__FILE__)."/../wp-attack-scanner-free-logs/"));
			}else{
				//already exists
			}

			if(!file_exists(dirname(__FILE__)."/../wp-attack-scanner-free-logs/data.txt")) {
				copy((dirname(__FILE__)."/data.txt"),(dirname(__FILE__)."/../wp-attack-scanner-free-logs/data.txt"));
			}else{
			//already exists
			}

			if(!file_exists(dirname(__FILE__)."/../wp-attack-scanner-free-logs/archive.txt")) {
				copy((dirname(__FILE__)."/archive.txt"),(dirname(__FILE__)."/../wp-attack-scanner-free-logs/archive.txt"));
			}else{
			//already exists
			}

			if(!file_exists(dirname(__FILE__)."/../wp-attack-scanner-free-logs/.htaccess")) {
				copy((dirname(__FILE__)."/.htaccess"),(dirname(__FILE__)."/../wp-attack-scanner-free-logs/.htaccess"));
			}else{
			//already exists
			}			
		
			$res = unserialize($request['body']);

			if ($res === false)
				$res = new WP_Error('plugins_api_failed', __('An unknown error occurred'), $request['body']);
		}

		return $res;
	
	}

/*
 * End Update Code
 */

require(dirname(__FILE__)."/Attacks.inc.php");
require(dirname(__FILE__)."/Logging.inc.php");
require(dirname(__FILE__)."/Cryptography.inc.php");




/****** Global Variables used in appened to data.txt in each function ***********/

//Check for CloudFlare header if true domain IP is sent with request - Credit @MattJezorek 01/03/2013
if (isset($_SERVER['HTTP_CF_CONNECTING_IP'])){
	$_SERVER['REMOTE_ADDR'] = $_SERVER['HTTP_CF_CONNECTING_IP'];
}

$ip = $_SERVER['REMOTE_ADDR'];

if (isset($ip)) 
{ 	
	$hostaddress = gethostbyaddr($ip);
} 
else 
{
	$hostaddress = $ip." - Could Not resolve Address"; 
}

if(isset($_SERVER['HTTP_USER_AGENT']))
{
	$browser = xssafe($_SERVER['HTTP_USER_AGENT']);
} 
else 
{
	$browser = "No User Agent Was Set - Possible Attack via Telnet or Automated Script";
}

if(isset($_SERVER['HTTP_REFERER'])) 
{
	$referred = xssafe($_SERVER['HTTP_REFERER']); 			// a quirky spelling mistake that stuck in php
} 
else 
{
	$referred = "No Referrer Sent";
}

$d1=date("m/d/y");
$d2=date("H");
$d3=date("i:s");
$d4=$d2;
$date=("$d1 $d4:$d3 ");

/***********	Utiltiy Functions	***********************************/

function MakeAttackArray()
{

	$attacks = array();
	array_push($attacks, new e107_syle_attacks());
	array_push($attacks, new WordPressTrackBack());
	array_push($attacks, new UsernameDeduction());
	array_push($attacks, new DirectoryTraversal());
	array_push($attacks, new RemoteFileInclusion());
	array_push($attacks, new XSS());
	array_push($attacks, new SQLi());
	array_push($attacks, new SourceDisclosure());
	array_push($attacks, new ListAllApache());
	return $attacks;
}

function GetAttackWithName($name)
{
	foreach(MakeAttackArray() as $key => $attack)
	{
		if($attack->GetAttackName() == $name)
		{
			return $attack;
		}
	}
}

function PrintAttackInformation($encoded, $index)
{
	$arr = LineToLogEntry($encoded);
	$attack = GetAttackWithName(xssafe($arr->attack));
	$html = "<div class=\"expanded_container\"><div class=\"log_entries\"><input type=\"checkbox\" class=\"entries\" name='entries[]' value=\"".$index."\" /></div><div class=\"expand\"><div class=\"collection\">";
	$html .= "&nbsp;&nbsp;Attack(#".$index."): <a href=\"".xssafe($attack->GetInformationURL())."\" target=\"_blank\">".xssafe($attack->GetAttackName())."</a><br />";
	$html .= "Timestamp: ".xssafe($arr->date)."<br />";
	$html .= "Click For Attacker Whois Lookup: <a class=\"alert\" title=\"Whois on ".xssafe($arr->hostaddress)."\"  target=\"_blank\" href=\"http://whois.domaintools.com/".xssafe($arr->hostaddress)."\">".xssafe($arr->ip)."</a><br />";
	$html .= "Hostname: ".xssafe($arr->hostaddress)."<br />";
	$html .= "Browser: ".xssafe($arr->browser)."<br />";
	$html .= "Referrer: ".xssafe($arr->referred)."<br />";
	$html .= "Method: ".xssafe($arr->method)."<br />";
	$html .= "Original URL Schema: ".xssafe($arr->text)."<br />";
	$html .= "Attack String Alone: ".xssafe($arr->rfi)."<br />";
	$html .= "</div> ".$arr->ipInformation->PrintIPInformation()."  </div></div>";
	return $html; 
}

function curPageURL() 
{
	$pageURL = 'http';
	if (isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] == "on") {$pageURL .= "s";} 	// Check if your site is HTTP or HTTPS
	$pageURL .= "://";
	if ($_SERVER["SERVER_PORT"] != "80") 
	{
		$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"].$_SERVER["REQUEST_URI"]; 	//Page is HTTPS
	} 
	else 
	{
		$pageURL .= $_SERVER["SERVER_NAME"].$_SERVER["REQUEST_URI"];	//Page is HTTP
	}
	return $pageURL;
}

/***********   Check for attacks via HTTP POST METHOD only ************/


function checkPOST_ATTACK() 
{    
	$newEntries = false;
	if (!empty($_POST) && !( is_super_admin() )) 
	//if (!empty($_POST) && !( is_user_logged_in() ))
	{
		foreach($_POST as $name => $value) 
		{
			$rfi_URL = curPageURL(); 					
			$text = $value;
			$rfi = $name."=".$value;
			
			foreach(MakeAttackArray() as $key => $attack)
			{
				if($attack->CheckForAttack($text) && !$attack->IsWhitelisted($rfi_URL, $name))
				{
					global $ip;global $hostaddress;global $browser;
					global $referred;global	$d1;global $d2;global $d3;
					global $d4;global $date;
					$log = new LogEntry($ip, $attack->GetAttackName(), date('Y-m-d H:i:s',current_time('timestamp', 0)), $hostaddress, $browser, $referred, $_SERVER['REQUEST_METHOD'], xssafe($rfi_URL), xssafe($rfi));
					AddLogEntry($log);
					$newEntries = true;
				}
			}
		} 
	}
	return $newEntries;
}

function checkGHTO_ATTACK()
{
	$newEntries = false;
	$text = curPageURL();
	$text = substr($text, strpos($text, "://") + 3);
	foreach(MakeAttackArray() as $key => $attack)
	{
		$found = false;
		foreach($_GET as $name => $value)
		{
			if($attack->CheckForAttack($value))
			{
				$found = true;
				if(!$attack->IsWhitelisted($text, $name))
				{
					global $ip;global $hostaddress;global $browser;
					global $referred;global	$d1;global $d2;global $d3;
					global $d4;global $date;
					$log = new LogEntry($ip, $attack->GetAttackName(), date('Y-m-d H:i:s',current_time('timestamp', 0)), $hostaddress, $browser, $referred, $_SERVER['REQUEST_METHOD'], xssafe(curPageURL()), xssafe($attack->GetInfringing($text)));
					AddLogEntry($log);
					$newEntries = true;
				}
			}
		}
		if(!$found && $attack->CheckForAttack($text) && !$attack->IsWhitelisted($text))
		{
			global $ip;global $hostaddress;global $browser;
			global $referred;global	$d1;global $d2;global $d3;
			global $d4;global $date;
			$log = new LogEntry($ip, $attack->GetAttackName(), date('Y-m-d H:i:s',current_time('timestamp', 0)), $hostaddress, $browser, $referred, $_SERVER['REQUEST_METHOD'], xssafe(curPageURL()), xssafe($attack->GetInfringing($text)));
			AddLogEntry($log);
			$newEntries = true;
		}
	}
	return $newEntries;
}

function check_real_spiders($string, $ignore) 
{
	if (is_array($ignore)) 
	{
		foreach ($ignore as $str) 
		{
			if (is_array($str)) 
			{
				$pos = check_real_spiders($string, $str);
			}
			else
			{
				$pos = strpos($string, $str);
			}
			if ($pos !== FALSE) 
			{
				return $pos;
			}
		}
	} 
	else 
	{
		return strpos($string, $ignore);
	}
}

function check_SEO_and_ADS() 
{ 
	global $hostaddress;
	if (check_real_spiders($hostaddress, array('googlebot.com', 'google.com', 'amazon.com', 'bing.com', 'msn.com')) == true) 
	{
		return true;
	} 
	else 
	{
		return false;
	}
}

function ScanForAttacks() 
{
	//if ( !is_super_admin() ) 
	if ( !is_user_logged_in() ) 
	{
		if(check_SEO_and_ADS() === true)
			return;
		$postAttack = checkPOST_ATTACK();
		$getAttack = checkGHTO_ATTACK();
		if($getAttack || $postAttack)
		{
			TrimLog(100, false);
		}
	}
}
add_action('init', 'ScanForAttacks');
	
function wp_attack_scanner_menu() 
{
	add_menu_page('WP-Attack Scanner Stats', 'Attack Scanner', 'add_users','attack_scanner', 'display_attacks' );
}

add_action('admin_menu', 'wp_attack_scanner_menu');

function display_attacks() 
{	
	echo "<link rel='stylesheet' id='wp-attack-scanner'  href='".plugins_url('wp-attack-scanner.css', __FILE__)."' type='text/css' media='all' />";
	echo "<br /><br /><div id=\"container\">\r\n<div id=\"page-title\"> WordPress Attack Scanner Known Results </div>\r\n<br /><small><a href=\"https://twitter.com/xxDigiPxx\" target=\"_blank\">Follow @xxdigipxx on Twitter</a> | <a href=\"https://twitter.com/bwallHatesTwits\" target=\"_blank\">Follow @bwallHatesTwits on Twitter</a></small>\r\n<br />\r\n";
	echo "<br /><br />\r\n\r\n<div id=\"results\">\r\n";
	//While data.txt is empty, we will hide check_form, but if it contains an entry, lets show the delete action form
	//echo "<script type='text/javascript'>function digi_showForm(){ document.getElementById(\"check_form\").style.display=\"block\"; } </script>";
	echo "<script type='text/javascript'>
				function checkAll(field)
				{
				for (i = 0; i < field.length; i++)
					field[i].checked = true ;
				}

				function uncheckAll(field)
				{
				for (i = 0; i < field.length; i++)
					field[i].checked = false ;
				}
		</script>";

	
	if(isset($_POST['action']) && isset($_POST['CONFIRMED']) && $_POST['CONFIRMED'] === "true" && isset($_POST['entries']) && count($_POST['entries']) > 0 && check_admin_referer('wp-attack-scanner-log-manipulation'))
	{
		if($_POST['action'] == "Delete" && ( is_super_admin() ))
		{
			//Delete		
			$myFile = dirname(__FILE__)."/data.txt";
			$handle = fopen($myFile, "r");
			if ($handle) 
			{
				$output = "";
				$index = 1;
				while (($buffer = fgets($handle)) !== false) 
				{
					$buffer = trim($buffer);
					if($buffer != "")
					{
						if(!in_array($index, $_POST['entries']))
						{
							$output .= $buffer."\n";
						}
						$index++;
					}
				}
				fclose($handle);
				file_put_contents(dirname(__FILE__)."/data.txt", $output, LOCK_EX);
			}		
		}
	}
	
	if(isset($_POST['action']) && !isset($_POST['CONFIRMED']) && isset($_POST['entries']) && count($_POST['entries']) > 0 && check_admin_referer('wp-attack-scanner-log-manipulation'))
	{
		$iamsure = "I am sure I want to ";
		$iamnot = "I am not sure I want to ";
		if($_POST['action'] == "Delete")
		{
			$iamsure .= "delete the selected log entries.";
			$iamnot .= "delete the selected log entries.";
		}
		echo "<form name=\"action_form\" method='POST'>
			<input type=\"radio\" name=\"CONFIRMED\" value=\"true\" /> $iamsure<br />
			<input type=\"radio\" name=\"CONFIRMED\" value=\"false\" /> $iamnot<br />
			<input type=\"hidden\" name=\"action\" value=\"".xssafe($_POST['action'])."\" />
			<input type=\"submit\" value=\"Make Decision\" /><br />";
		if ( function_exists('wp_nonce_field') ) 
			wp_nonce_field('wp-attack-scanner-log-manipulation');
		$N = count($_POST['entries']);
		for($i = 0; $i < $N; $i++)
		{
			echo "<input type='hidden' name='entries[]' value='".xssafe($_POST['entries'][$i])."'/>";
		}
		echo "</form>";
	}
	else
	{					
		echo "<div id=\"check_form\"><form name=\"myform\" method=\"post\">
				<input class=\"digi_buttons\" type=\"button\" name=\"CheckAll\" value=\"Check All\" onClick=\"checkAll(document.getElementsByClassName('entries'))\" />
				<input class=\"digi_buttons\" type=\"button\" name=\"UnCheckAll\" value=\"Uncheck All\" onClick=\"uncheckAll(document.getElementsByClassName('entries'))\" />
				<select class=\"digi_buttons\" name=\"action\">
					<option value=\"Delete\">Delete</option>
				</select><input class=\"digi_buttons\" type=\"submit\" value=\"Act on Selected Items\" /><br /><br />";
		if ( function_exists('wp_nonce_field') ) 
			wp_nonce_field('wp-attack-scanner-log-manipulation');

		/** Read data.txt and load it on the admin panel **/
		$myFile = dirname(__FILE__)."/data.txt";
		$handle = fopen($myFile, "r");
		if ($handle) 
		{
			$index = 1;
			while (($buffer = fgets($handle)) !== false) 
			{	
				//echo "<script type=\"text/javascript\">digi_showForm();</script>";
			
				$buffer = trim($buffer);
				if($buffer != "")
				{
					echo PrintAttackInformation($buffer, $index);
					$index++;
				}
			}
			fclose($handle);
		}		
		echo "</form><br />";
	}
			
	echo "\r\n</div><!-- end results -->\r\n<br /></div><!-- end container-->";
}

function wp_attack_scanner_menu_config() 
{
	add_submenu_page( 'attack_scanner', 'WP-Attack Scanner Settings', 'Configure Settings', 'add_users', 'attack_scanner_config', 'display_configure_settings' );
}

add_action('admin_menu', 'wp_attack_scanner_menu_config');

function display_configure_settings() 
{
	echo "<link rel='stylesheet' id='wp-attack-scanner'  href='".plugins_url('wp-attack-scanner.css', __FILE__)."' type='text/css' media='all' />";
	echo "<br /><br /><div id=\"container\">\r\n<div id=\"page-title\"> WordPress Attack Scanner Configuration </div>\r\n<br /><small><a href=\"https://twitter.com/xxDigiPxx\" target=\"_blank\">Follow @xxdigipxx on Twitter</a> | <a href=\"https://twitter.com/bwallHatesTwits\" target=\"_blank\">Follow @bwallHatesTwits on Twitter</a></small>\r\n<br />\r\n";
	echo "<br /><br />\r\n\r\n<div id=\"results\">\r\n";

	if(isset($_POST['restore']) && check_admin_referer('wp-attack-scanner-restore') && ( is_super_admin() )){
		if(file_exists(dirname(__FILE__)."/../wp-attack-scanner-free-logs/data.txt")) {
				copy((dirname(__FILE__)."/../wp-attack-scanner-free-logs/data.txt"),(dirname(__FILE__)."/data.txt"));
				copy((dirname(__FILE__)."/../wp-attack-scanner-free-logs/archive.txt"),(dirname(__FILE__)."/archive.txt"));
		}
	//Remove Old Backups
	unlink(dirname(__FILE__)."/../wp-attack-scanner-free-logs/data.txt");
	unlink(dirname(__FILE__)."/../wp-attack-scanner-free-logs/archive.txt");
	unlink(dirname(__FILE__)."/../wp-attack-scanner-free-logs/.htaccess");
	rmdir(dirname(__FILE__)."/../wp-attack-scanner-free-logs/");
	}
	
if (file_exists(dirname(__FILE__)."/../wp-attack-scanner-free-logs/data.txt")) {
	echo "<div id=\"max-log\">";
	echo "<form method='POST' title='Restore Logs After Upgrade'>";
	echo "<input type='hidden' name='restore' value='yuuup'/>";
	echo "<table>";
	if ( function_exists('wp_nonce_field') && ( is_super_admin() ) ) 
			wp_nonce_field('wp-attack-scanner-restore');
	echo "<tr><td>Restore Logs </td><td><input class='restore' type='submit' value='  Restore Logs After Upgrade  '  /></td></tr>";
	echo "</table>";
	echo "</form>";
	echo "</div><br /><br /><!-- end Restore Logs -->";
	}	

	
	if(isset($_POST['save']) && check_admin_referer('wp-attack-scanner-configuration') && ( is_super_admin() ))
	{
		$encPass = get_option("AttackScannerEncPass");
		if($encPass === false)
		{
			add_option("AttackScannerEncPass", $_POST['EncPass'], "", "yes");
		}
		else if($_POST['EncPass'] !== $encPass)
		{
			//Decrypt everything
			$dataLines = array();
			$myFile = dirname(__FILE__)."/data.txt";
			$handle = fopen($myFile, "r");
			if ($handle) 
			{		
				while (($buffer = fgets($handle)) !== false) 
				{
					$buffer = trim($buffer);
					if($buffer != "")
					{
						$crypt = new ARCbwall($encPass);						
						array_push($dataLines, $crypt->Crypt(base64_decode($buffer)));
					}
				}
			}
			$archiveLines = array();
			$myFile = dirname(__FILE__)."/archive.txt";
			$handle = fopen($myFile, "r");
			if ($handle) 
			{		
				while (($buffer = fgets($handle)) !== false) 
				{
					$buffer = trim($buffer);
					if($buffer != "")
					{
						$crypt = new ARCbwall($encPass);						
						array_push($archiveLines, $crypt->Crypt(base64_decode($buffer)));
					}
				}
			}
			
			update_option("AttackScannerEncPass", $_POST['EncPass']);
			$encPass = $_POST['EncPass'];		
			//Re-encrypt everything	
			$data = "";
			for($i = 0; $i < count($dataLines); $i++)
			{
				$crypt = new ARCbwall($encPass);
				$data .= base64_encode($crypt->Crypt($dataLines[$i]))."\n";
			}
			file_put_contents(dirname(__FILE__)."/data.txt", $data, LOCK_EX);
			
			$archive = "";
			for($i = 0; $i < count($archiveLines); $i++)
			{
				$crypt = new ARCbwall($encPass);
				$archive .= base64_encode($crypt->Crypt($archiveLines[$i]))."\n";
			}
			file_put_contents(dirname(__FILE__)."/archive.txt", $archive, LOCK_EX);
		}
	}
	
	$encPass = "Change Me";
	$encPass = get_option("AttackScannerEncPass");
	if($encPass === false)
	{
		add_option("AttackScannerEncPass", "Change Me", "", "yes");
		$encPass = get_option("AttackScannerEncPass");
	}

	echo "<div id=\"max-log\">";
	echo "<form method='POST' title='This change is not immediate, and will take effect the next time a new log entry is generated.'>";
	echo "<table>";
	if ( function_exists('wp_nonce_field') && ( is_super_admin() ) ) 
			wp_nonce_field('wp-attack-scanner-configuration');
	echo "<tr><td>Encryption Password </td><td><input type='text' name='EncPass' value='$encPass' title='TIP: This is the key used to encrypt data.txt and archive.txt so you can move them to other servers while keeping all data from prying eyes.' /></td></tr>";
	echo "<tr><td><input class='config_save' type='submit' value='  Save All Changes  '  /></td></tr>";
	echo "</table>";
	echo "<input type='hidden' name='save' value='yuuup'/>";
	echo "</form>";
	echo "</div><!-- end Max Log Count -->";

	
	echo "\r\n</div><!-- end results -->\r\n<br /></div><!-- end container-->";
	
}

function wp_attack_scanner_menu_stats() 
{
	add_submenu_page( 'attack_scanner', 'WP-Attack Scanner Statistics', 'Statistics', 'add_users', 'attack_scanner_stats', 'display_attack_stats' );
}

add_action('admin_menu', 'wp_attack_scanner_menu_stats');

function display_attack_stats() 
{
	echo "<link rel='stylesheet' id='wp-attack-scanner'  href='".plugins_url('wp-attack-scanner.css', __FILE__)."' type='text/css' media='all' />";
	echo "<br /><br /><div id=\"container\">\r\n<div id=\"page-title\"> WordPress Attack Scanner Statistics </div>\r\n<br /><small><a href=\"https://twitter.com/xxDigiPxx\" target=\"_blank\">Follow @xxdigipxx on Twitter</a> | <a href=\"https://twitter.com/bwallHatesTwits\" target=\"_blank\">Follow @bwallHatesTwits on Twitter</a></small>\r\n<br />\r\n";
	echo "<br /><br />\r\n\r\n<div id=\"results\">\r\n";
	
	$entries = GetAllLogEntries(true);
	$ip = array();
	$country = array();
	$attackStrings = array();
	$methods = array();
	$latstring = "";
	foreach($entries as $index => $entry)
	{
		if(!array_key_exists($entry->ip, $ip))
		{
			$ip[$entry->ip] = 0;
			if(isset($entry->ipInformation->data->Latitude) && strlen($entry->ipInformation->data->Latitude) > 0)
			{
				if($latstring != "")
				{
					$latstring .= "\n";
				}
				$latstring .= "new GLatLng(".$entry->ipInformation->data->Latitude.','.$entry->ipInformation->data->Longitude."),";
			}
		}
		if(!array_key_exists($entry->ipInformation->data->CountryName, $country))
		{
			$country[$entry->ipInformation->data->CountryName] = 0;
		}
		if(!array_key_exists($entry->ipInformation->data->City, $city))
		{
			$city[$entry->ipInformation->data->City] = 0;
		}
		if(!array_key_exists($entry->ipInformation->data->Region, $region))
		{
			$region[$entry->ipInformation->data->Region] = 0;
		}
		if(!array_key_exists($entry->rfi, $attackStrings))
		{
			$attackStrings[$entry->rfi] = 0;
		}
		if(!array_key_exists($entry->method, $methods))
		{
			$methods[$entry->method] = 0;
		}
		if(!array_key_exists($entry->attack, $attack)){
			$attack[$entry->attack] = 0;
		}		
		//$entry->text is home Base url
		if(!array_key_exists($entry->text, $text)){
			$text[$entry->text] = 0;
		}
		
		$region[$entry->ipInformation->data->Region]++;
		$city[$entry->ipInformation->data->City]++;
		$text[$entry->text]++;
		$attack[$entry->attack]++;
		$methods[$entry->method]++;
		$attackStrings[$entry->rfi]++;
		$ip[$entry->ip]++;
		$country[$entry->ipInformation->data->CountryName]++;
	}
	
	arsort($region);
	arsort($city);
	arsort($text);
	arsort($attack);
	arsort($ip);
	arsort($country);
	arsort($attackStrings);
	arsort($methods);
	$count = 0;
	
	echo "<div class=\"stats\">";
		print "<h3 title=\"This reflects plug-ins they looked for, whether installed or not!\">Top 10 Attacked Plug-ins </h3><br /><br />";
	$count = 0;
	foreach($text as $i => $c)
	{
		$count++;
		if($count == 10)
		{
			break;
		}
		$i = strstr($i,'/wp-content/plugins/');
		$i = substr($i, 0, strpos($i, "?"));
		if($i != ""){
		print "<p>".$i." was attacked ".$c." times.</p>";
		}
	}
	echo "</div>";	
	
	echo "<div class=\"stats\">";
		print "<h3 title=\"This reflects themes they looked for, whether installed or not!\">Top 10 Attacked Themes </h3><br /><br />";
	$count = 0;
	foreach($text as $i => $c)
	{
		$count++;
		if($count == 10)
		{
			break;
		}
		$i = strstr($i,'/wp-content/themes/');
		$i = substr($i, 0, strpos($i, "?"));
		if($i != ""){
		print "<p>".$i." was attacked ".$c." times.</p>";
		}
	}
	echo "</div>";	
	
	echo "<div class=\"stats\">";
		print "<h3>Top 10 Attack Types </h3><br /><br />";
	$count = 0;
	foreach($attack as $i => $c)
	{
		$count++;
		if($count == 10)
		{
			break;
		}
		print "<p>".$i." was used ".$c." times.</p>";
	}
	echo "</div>";
	
	echo "<div class=\"stats\">";
		print "<h3>Top 10 HTTP/Connect Methods</h3><br /><br />";
	$count = 0;
	foreach($methods as $i => $c)
	{
		$count++;
		if($count == 10)
		{
			break;
		}
		print "<p>".$i." was used ".$c." times.</p>";
	}
	echo "</div>";	
	
	echo "<div class=\"stats\">";
		print "<h3>Top 10 Attack Strings</h3><br /><br />";
	$count = 0;
	foreach($attackStrings as $i => $c)
	{
		$count++;
		if($count == 10)
		{
			break;
		}
		print "<p>".$i." was used ".$c." times.</p>";
	}
	echo "</div>";
	
	echo "<div class=\"stats\">";
		print "<h3>Top 10 Attackers By IP</h3><br /><br />";
	$count = 0;
	foreach($ip as $i => $c)
	{
		$count++;
		if($count == 10)
		{
			break;
		}
		print "<p>".$i." attacked ".$c." times.</p>";
	}
	echo "</div>";
	
	echo "<div class=\"stats\">";
		print "<h3>Top 10 Attacks By Country</h3><br /><br />";
	$count = 0;
	foreach($country as $i => $c)
	{
		$count++;
		if($count == 10)
		{
			break;
		}
		print "<p>".$i." attacked ".$c." times.</p>";
	}
	echo "</div>";
	
	echo "<div class=\"stats\">";
		print "<h3>Top 10 Attacks By City</h3><br /><br />";
	$count = 0;
	foreach($city as $i => $c)
	{
		$count++;
		if($count == 10)
		{
			break;
		}
		print "<p>".$i." attacked ".$c." times.</p>";
	}
	echo "</div>";

	echo "<div class=\"stats\">";
		print "<h3>Top 10 By State/Region</h3><br /><br />";
	$count = 0;
	foreach($region as $i => $c)
	{
		$count++;
		if($count == 10)
		{
			break;
		}
		print "<p>".$i." attacked ".$c." times.</p>";
	}
	echo "</div>";
	
	echo "\r\n</div>
	
	<!-- end results -->\r\n<br /></div><!-- end container-->";
	
}

function wp_attack_scanner_menu_about_us() 
{
	add_submenu_page( 'attack_scanner', 'WP-Attack Scanner About Us', 'About Us', 'add_users', 'attack_scanner_about_us', 'display_about_us' );
}

add_action('admin_menu', 'wp_attack_scanner_menu_about_us');

function display_about_us() 
{
	echo "<link rel='stylesheet' id='wp-attack-scanner'  href='".plugins_url('wp-attack-scanner.css', __FILE__)."' type='text/css' media='all' />";
	echo "<br /><br /><div id=\"container\">\r\n<div id=\"page-title\"> WordPress Attack Scanner About Us </div>\r\n<br /><small><a href=\"https://twitter.com/xxDigiPxx\" target=\"_blank\">Follow @xxdigipxx on Twitter</a> | <a href=\"https://twitter.com/bwallHatesTwits\" target=\"_blank\">Follow @bwallHatesTwits on Twitter</a></small>\r\n<br />\r\n";
	echo "<br /><br />\r\n\r\n<div id=\"results\">\r\n";
	
		echo "<div id=\"digi-credits\">";
		
print "<div id='thanks'>
<form title='Please help contribute to our development fund.' style='float:right; position:relative; top:-50px; margin-bottom:-30px;' action='https://www.paypal.com/cgi-bin/webscr' method='post'>
<input type='hidden' name='cmd' value='_s-xclick' />
<input type='hidden' name='hosted_button_id' value='G4F6YLVF2P9VU' />
<input type='image' src='https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif' border='0' name='submit' alt='PayPal - The safer, easier way to pay online!' />
<img alt='' border='0' src='https://www.paypalobjects.com/en_US/i/scr/pixel.gif' width='1' height='1' />
</form>

<h2>Setup Instructions</h2>
<p>
1. Upload our plug-in to the `/wp-content/plugins/` directory	<br />
2. Activate the plugin through the 'Plugins' menu in WordPress <br />
3. Go to the Admin dashboard and configure the plug-in <br />
4. CHANGE THE DEFAULT PASSWORD and then save your options <br />
</p>

<h2>Thank you for using our plug-in!</h2>

<p>First and foremost, we would like to say thank you for trying our WordPress Plug-In. We hope you find it useful. We look forward to your feedback, bug reports, and feature requests on how we can improve this plug-in. However, you are currently using the free version of our plug-in, and not getting the full benefits we offer to keep your WordPress site secure.</p>

<p>For starters, this version of the plug-in, does not block any of the attacks you see on your logs. It is only meant as a way for you to see what is truly happening to your site, so that you can effectively take action against possible threats to your site.</p>

<p>In the full, paid for version, we not only offer a built in Firewall that blocks any attacks you find on your logs, but we also offer you the ability to archive, as well as download all of your attack logs. You can export them to a CSV file (Comma Separated Value File) for use in any spreadsheet program, such as Excel for Microsoft Office, or save them to a GZIP file before deleting any of your current logs. The free version only keeps track of the 100 most recent attacks, and then starts deleting the oldest one for every new attack that is logged. By having the paid for version, you get unlimited logging and export capabilities, which offers you a sortable table and the ability to drill down on specific attacks, IP addresses and so forth, or import this data into other security products to be used for building your own server firewall rules, or IP ban lists. We also show you a map of your attackers on the statistics screen.<br /><br /><small>(Disclaimer: Google Maps Functionality is not built in by default to the free version of the stats screen!)</small></p>

<p>Our paid for version also offers you full support and bug fixes tailored to your sites needs. With your annual subscription, you get all this and more, including the ability to contribute anonymous statistics for which we will be publishing quarterly newsletters on our site, only for paid subscribers, which will show you the emerging attack trends for WordPress, the most attacked Plug-ins and Themes, as well as the most tried attack methods, in addition to where the most attacks are originating from. The stats page in the full version will also contain more info than the free version.</p>

<p>Our plug-in has already caught a potential 0-day in the wild, while we were testing. More info on this to be released at a later date, after the author fixes their plug-in. The whole point of this plug-in, is to help you prevent attacks, but also to capture unknown or potential threats in the wild. That was the core inspiration for building this plug-in, and by contributing your own anonymous data, we can better serve the WordPress community at large by finding these un-published attack vectors and reporting them to our subscribers and the public at large.</p>

<h2>More ways to protect your site!</h2>

<p>We will also be incorporating an IP ban list feature, offered to us by the creator and author of Artillery, as well as numerous other security products, written by none other than Dave Kennedy of <a href='https://www.trustedsec.com' target='_blank'>TrustedSec</a>. Dave has been kind enough to share  whith us his central database of banned attackers from his own customer contributed attack data.</p>

<p>While we continue to develop and improve this plug-in, we are also working to make this plug-in even better with features that will be available in the future, based on your feedback and feature requests. These will only be available to paid subscribers! Because we truly care about the security of your WordPress sites(and our own), we are working to add additional features that will compliment your existing security infrastructure. These features will come out at a later date in time, but here are a few of the ideas we have already, such as an NMAP NSE script, that will simulate the attacks tried right from your logs, for which you can use to test your other sites and servers for the same vulnerabilities.</p>

<p>For the new or novice users of WordPress, having our built-in firewall is always a plus with the paid for version, but for the IT Ninja and Information Security Guru's, we are looking to put together some other tools you may need or want as part of this plug-in. Your feedback and suggestions will help determine what we add next, so we encourage you to subscribe, test, and five us your feedback on what your company or IT Security Team needs to keep your site secured. On the horizon are ideas and features such as an IPTABLES rule blocker or even a built in ability to add to your IPTABLES rules automatically at the click of a button(depending on your OS and server capabilities of course), or to build custom SNORT rules to help you further secure your server and find attacks you've never seen before. Whatever those features become, will be solely based on your feedback to us, so we encourage you to submit ideas and feature requests. As paid subscribers, we want to help tailor this plug-in to your needs, and what you find useful the most, not because we think you need it, but because you tell us what you want in it!</p>

<h2>Please Vist Our Site</h2>

<p>I would like to take this time, to ask you to visit and <a href='http://www.attack-scanner.com/' target='_blank'>bookmark our home site, Attack-Scanner.com</a>, so you can stay up to date on all of our new features, bug fixes, and ideas, as well as submit your own feedback and ideas or feature requests.</p>

<hr />

<h2>Credits and Thanks</h2>

<table id='about_us_credits' border='0'>
<tr><th>Authors and Contibutors</th><th>Twitter Handle</th><th>Website</th></tr>
<tr><td>Tick Tock Computers, LLC</td><td>@xxDigiPxx</td><td>http://www.ticktockcomputers.com/</td></tr>
<tr><td>Ballast Security & FireBwall</td><td>@bwallHatesTwits</td><td>http://ballastsec.blogspot.com/</td></tr>
<tr><td>TrustedSec, LLC</td><td>@TrustedSec</td><td>https://www.trustedsec.com/</td></tr>
<tr><th colspan='3'>&copy WP Attack Scanner 2012-Present, All Rights Reserved</th></tr>
</table>

<p>Special thanks to <a href=\"https://twitter.com/MattJezorek\">@MattJezorek</a> for the CloudFlare Header IP check suggestion.</p>

<p>We would also like to thank our early beta-testers and contributors for their feedback and ideas, and for letting us use your sites as a test bed for our early versions of the plug-in.</p>

<p>Credit in part goes to http://www.maxmind.com/ for the GeoIP lookup database, which in part allows us to track where the attackers are from around the world.</p>

<p>Credit to Dave Kennedy at https://www.trustedsec.com/ for the use of his Artillery IP Ban List and consultation.</p>


<p>Last but not least, thank you for using our plug-in. We look forward to hearing from you, and where the future will take us with each new version of this plug-in.</p>

<h2>Please Help Us Continue Development</h2>

<p>If you would not like to upgrade to the full version, but find this plug-in useful, please feel free to donate a contribution to help us keep up development. Without your support, we would not be able to maintain and keep working on this plug-in. All and any donations are welcome, and none are considered too small. Our promise to you, is to keep improving and updating this plug-in for as long as we can sustain development. We all work day jobs outside of this project, as well as have families and children to attend to, so any contribution, no matter how small is greatly appreciated.
</p>

<form action='https://www.paypal.com/cgi-bin/webscr' method='post'>
<input type='hidden' name='cmd' value='_s-xclick' />
<input type='hidden' name='hosted_button_id' value='G4F6YLVF2P9VU' />
<input type='image' src='https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif' border='0' name='submit' alt='PayPal - The safer, easier way to pay online!' />
<img alt='' border='0' src='https://www.paypalobjects.com/en_US/i/scr/pixel.gif' width='1' height='1' />
</form>


<br /><br />";

echo "<p><li class=\"sincerely\"><a class=\"sincerely_link\" href=\"http://www.attack-scanner.com/\" target=\"_blank\"></a></li></p></div>";

		echo "</div><!-- end credits -->";
	
	
	echo "\r\n</div><!-- end results -->\r\n<br /></div><!-- end container-->";
	
}

add_filter('plugin_row_meta', 'add_plugin_meta_links', 10, 2);

function add_plugin_meta_links($links, $file) 
{
	$plugin_name = "wp-attack-scanner/wp-attack-scanner.php";
	if ($file == "$plugin_name") 
	{
		$links[] = 'Co-Author: <a href="http://ballastsec.blogspot.com/">@bwallHatesTwits</a>';
		$links[] = '<a href="http://www.ticktockcomputers.com/contact/">Support or Error Reporting</a>';
	}
	return $links;
}

function digi_change_comment_author_class( $classes ) {
    foreach( $classes as $key => $class ) {
        // change adminuser to your admin username
        if(strstr($class, 'comment-author-' . sanitize_html_class($user->user_nicename, $comment->user_id) )) {
            // change regularuser to the user you comment with
            $classes[$key] = 'comment-author-goaway';
        }
    }
    return $classes;
}

function change_comment_author($author)
{
    if(strstr($author,sanitize_html_class($user->user_nicename, $comment->user_id))) 
    { 
        return "goaway"; 
    }
    return $author;
}

add_filter( 'comment_class' , 'digi_change_comment_author_class' );
add_filter( 'get_comment_author' , 'change_comment_author' );


/****** Lock log files so they are NOT downloadable by anyone, but still accessible by the local server to read, write, etc - Testing DigiP 08/17/2012 ******/
$self_ip = $_SERVER["SERVER_NAME"];$htaccess = "####### WP-ATTACK-SCANNER PROTECT LOGS ####### \r\n<Files *.txt >\r\ndeny from all\r\nallow from ".gethostbyname($self_ip)."\r\n</Files>";
file_put_contents(dirname(__FILE__)."/.htaccess", $htaccess, LOCK_EX);
?>